# Get rate by ID

Retrieve a previously queried rate by its ID

Endpoint: GET /v1/rates/{rate_id}
Version: 1.1.202604070904
Security: api_key

## Path parameters:

  - `rate_id` (string, required)
    Rate ID
    Example: "se-28529731"

## Response 200 fields (application/json):

  - `rates` (array)
    An array of shipment rates

  - `rates.rate_id` (string,null)
    A string that uniquely identifies the rate
    Example: "se-28529731"

  - `rates.rate_type` (string, required)
    The possible rate type values
    Enum: "check", "shipment", "quick"

  - `rates.carrier_id` (string, required)
    A string that uniquely identifies the carrier
    Example: "se-28529731"

  - `rates.shipping_amount` (object, required)
    The shipping amount. Should be added with confirmation_amount, insurance_amount and other_amount to calculate the total purchase price.

  - `rates.shipping_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `rates.shipping_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `rates.insurance_amount` (object, required)
    The insurance amount.  Should be added with shipping_amount, confirmation_amount and other_amount to calculate the total purchase price.

  - `rates.insurance_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `rates.insurance_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `rates.confirmation_amount` (object, required)
    The confirmation amount.  Should be added with shipping_amount, insurance_amount and other_amount to calculate the total purchase price.

  - `rates.confirmation_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `rates.confirmation_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `rates.other_amount` (object, required)
    Any other charges associated with this rate.  Should be added with shipping_amount, insurance_amount and confirmation_amount to calculate the total purchase price.

  - `rates.other_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `rates.other_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `rates.requested_comparison_amount` (object)
    The total shipping cost for the specified comparison_rate_type.

  - `rates.requested_comparison_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `rates.requested_comparison_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `rates.tax_amount` (object)
    Tariff and additional taxes associated with an international shipment.

  - `rates.tax_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `rates.tax_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `rates.rate_details` (array)
    A list of rate details that are associated with this rate. This is useful for displaying a breakdown of the rate to the user.

  - `rates.rate_details.rate_detail_type` (string)
    The category of charge. Common values include shipping and additional_fees. DDP shipments (customs.terms_of_trade_code: "ddp") also return prepaid_duties, prepaid_taxes and prepaid_import_fees on Wallet carriers, or estimated_duties, estimated_taxes and estimated_import_fees on BYOA (Bring Your Own Account) carriers.
    Enum: "uncategorized", "shipping", "insurance", "confirmation", "discount", "fuel_charge", "additional_fees", "tariff", "tax", "delivery", "handling", "special_goods", "pickup", "location_fee", "oversize", "returns", "notifications", "tip", "duties_and_taxes", "brokerage_fee", "admin_fee", "adjustment", "prepaid_duties", "prepaid_taxes", "prepaid_import_fees", "estimated_duties", "estimated_taxes", "estimated_import_fees"

  - `rates.rate_details.carrier_description` (string,null)
    The carrier-provided description of the charge.
    Example: "Shipping"

  - `rates.rate_details.carrier_billing_code` (string,null)
    The carrier billing code, when provided by the carrier.
    Example: "BaseServiceCharge"

  - `rates.rate_details.carrier_memo` (string,null)
    An optional carrier-supplied note for the charge.

  - `rates.rate_details.amount` (object)
    The amount of this individual charge.

  - `rates.rate_details.amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `rates.rate_details.amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `rates.rate_details.rate_detail_attributes` (object)
    If applicable, contains additional data about a rate detail of a specific type, e.g. VAT

  - `rates.rate_details.rate_detail_attributes.tax_type` (string)
    Type of a tax added to shipping cost. Includes Canadian tax types GST (Goods and Services Tax), HST (Harmonized Sales Tax), QST (Quebec Sales Tax), and PST (Provincial Sales Tax).
    Enum: "vat", "gst", "hst", "qst", "pst"

  - `rates.rate_details.rate_detail_attributes.tax_percentage` (number)
    Tax percentage, e.g. 20 for 20%, added to the shipping cost

  - `rates.rate_details.billing_source` (string)
    The source that produced the charge. Common values are carrier for carrier-billed charges and dutiestax for duties and taxes on DDP shipments (prepaid on Wallet carriers, estimated on BYOA carriers).
    Example: "carrier"

  - `rates.carrier_weight` (object,null)
    The billable weight assessed by the carrier, based on the weight and dimensions submitted with the rate request.

  - `rates.carrier_weight.value` (number, required)
    The weight, in the specified unit

  - `rates.carrier_weight.unit` (string, required)
    The possible weight unit values
    Enum: "pound", "ounce", "gram", "kilogram"

  - `rates.display_scheme` (string,null)
    The display format for the label this rate would produce.
    Enum: "label", "qr_code", "label_and_qr_code", "paperless", "label_and_paperless", "no_box_no_label"

  - `rates.zone` (integer,null, required)
    Certain carriers base [their rates](https://blog.stamps.com/2017/09/08/usps-postal-zones/) off of
custom zones that vary depending upon the ship_to and ship_from location
    Example: 6

  - `rates.package_type` (string,null, required)
    package type that this rate was estimated for
    Example: "package"

  - `rates.delivery_days` (integer,null)
    The number of days estimated for delivery, this will show the _actual_ delivery
time if for example, the package gets shipped on a Friday
    Example: 5

  - `rates.guaranteed_service` (boolean, required)
    Indicates if the rate is guaranteed.

  - `rates.estimated_delivery_date` (string,null)
    An [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) string that represents a date, but not a specific time.  The value _may_ contain a time component, but it will be set to 00:00:00 UTC by ShipEngine.
    Example: "2018-09-23T00:00:00.000Z"

  - `rates.carrier_delivery_days` (string,null)
    The carrier delivery days

  - `rates.ship_date` (string)
    ship date

  - `rates.negotiated_rate` (boolean, required)
    Indicates if the rates been negotiated

  - `rates.service_type` (string, required)
    service type

  - `rates.service_code` (string, required)
    service code for the rate

  - `rates.trackable` (boolean, required)
    Indicates if rate is trackable

  - `rates.carrier_code` (string, required)
    carrier code

  - `rates.carrier_nickname` (string, required)
    carrier nickname

  - `rates.carrier_friendly_name` (string, required)
    carrier friendly name

  - `rates.validation_status` (string, required)
    The possible validation status values
    Enum: "valid", "invalid", "has_warnings", "unknown"

  - `rates.warning_messages` (array, required)
    The warning messages

  - `rates.error_messages` (array, required)
    The error messages

  - `rates.rate_attributes` (array)
    Optional attributes that indicate the most profitable rates
    Enum: "best_value", "cheapest", "fastest"

  - `invalid_rates` (array)
    An array of invalid shipment rates

  - `invalid_rates.rate_id` (string,null)
    A string that uniquely identifies the rate
    Example: "se-28529731"

  - `invalid_rates.rate_type` (string, required)
    The possible rate type values
    Enum: "check", "shipment", "quick"

  - `invalid_rates.carrier_id` (string, required)
    A string that uniquely identifies the carrier
    Example: "se-28529731"

  - `invalid_rates.shipping_amount` (object, required)
    The shipping amount. Should be added with confirmation_amount, insurance_amount and other_amount to calculate the total purchase price.

  - `invalid_rates.shipping_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `invalid_rates.shipping_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `invalid_rates.insurance_amount` (object, required)
    The insurance amount.  Should be added with shipping_amount, confirmation_amount and other_amount to calculate the total purchase price.

  - `invalid_rates.insurance_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `invalid_rates.insurance_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `invalid_rates.confirmation_amount` (object, required)
    The confirmation amount.  Should be added with shipping_amount, insurance_amount and other_amount to calculate the total purchase price.

  - `invalid_rates.confirmation_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `invalid_rates.confirmation_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `invalid_rates.other_amount` (object, required)
    Any other charges associated with this rate.  Should be added with shipping_amount, insurance_amount and confirmation_amount to calculate the total purchase price.

  - `invalid_rates.other_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `invalid_rates.other_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `invalid_rates.requested_comparison_amount` (object)
    The total shipping cost for the specified comparison_rate_type.

  - `invalid_rates.requested_comparison_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `invalid_rates.requested_comparison_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `invalid_rates.tax_amount` (object)
    Tariff and additional taxes associated with an international shipment.

  - `invalid_rates.tax_amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `invalid_rates.tax_amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `invalid_rates.rate_details` (array)
    A list of rate details that are associated with this rate. This is useful for displaying a breakdown of the rate to the user.

  - `invalid_rates.rate_details.rate_detail_type` (string)
    The category of charge. Common values include shipping and additional_fees. DDP shipments (customs.terms_of_trade_code: "ddp") also return prepaid_duties, prepaid_taxes and prepaid_import_fees on Wallet carriers, or estimated_duties, estimated_taxes and estimated_import_fees on BYOA (Bring Your Own Account) carriers.
    Enum: "uncategorized", "shipping", "insurance", "confirmation", "discount", "fuel_charge", "additional_fees", "tariff", "tax", "delivery", "handling", "special_goods", "pickup", "location_fee", "oversize", "returns", "notifications", "tip", "duties_and_taxes", "brokerage_fee", "admin_fee", "adjustment", "prepaid_duties", "prepaid_taxes", "prepaid_import_fees", "estimated_duties", "estimated_taxes", "estimated_import_fees"

  - `invalid_rates.rate_details.carrier_description` (string,null)
    The carrier-provided description of the charge.
    Example: "Shipping"

  - `invalid_rates.rate_details.carrier_billing_code` (string,null)
    The carrier billing code, when provided by the carrier.
    Example: "BaseServiceCharge"

  - `invalid_rates.rate_details.carrier_memo` (string,null)
    An optional carrier-supplied note for the charge.

  - `invalid_rates.rate_details.amount` (object)
    The amount of this individual charge.

  - `invalid_rates.rate_details.amount.currency` (string, required)
    The currencies that are supported by ShipEngine are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html

  - `invalid_rates.rate_details.amount.amount` (number, required)
    The monetary amount, in the specified currency.

  - `invalid_rates.rate_details.rate_detail_attributes` (object)
    If applicable, contains additional data about a rate detail of a specific type, e.g. VAT

  - `invalid_rates.rate_details.rate_detail_attributes.tax_type` (string)
    Type of a tax added to shipping cost. Includes Canadian tax types GST (Goods and Services Tax), HST (Harmonized Sales Tax), QST (Quebec Sales Tax), and PST (Provincial Sales Tax).
    Enum: "vat", "gst", "hst", "qst", "pst"

  - `invalid_rates.rate_details.rate_detail_attributes.tax_percentage` (number)
    Tax percentage, e.g. 20 for 20%, added to the shipping cost

  - `invalid_rates.rate_details.billing_source` (string)
    The source that produced the charge. Common values are carrier for carrier-billed charges and dutiestax for duties and taxes on DDP shipments (prepaid on Wallet carriers, estimated on BYOA carriers).
    Example: "carrier"

  - `invalid_rates.carrier_weight` (object,null)
    The billable weight assessed by the carrier, based on the weight and dimensions submitted with the rate request.

  - `invalid_rates.carrier_weight.value` (number, required)
    The weight, in the specified unit

  - `invalid_rates.carrier_weight.unit` (string, required)
    The possible weight unit values
    Enum: "pound", "ounce", "gram", "kilogram"

  - `invalid_rates.display_scheme` (string,null)
    The display format for the label this rate would produce.
    Enum: "label", "qr_code", "label_and_qr_code", "paperless", "label_and_paperless", "no_box_no_label"

  - `invalid_rates.zone` (integer,null, required)
    Certain carriers base [their rates](https://blog.stamps.com/2017/09/08/usps-postal-zones/) off of
custom zones that vary depending upon the ship_to and ship_from location
    Example: 6

  - `invalid_rates.package_type` (string,null, required)
    package type that this rate was estimated for
    Example: "package"

  - `invalid_rates.delivery_days` (integer,null)
    The number of days estimated for delivery, this will show the _actual_ delivery
time if for example, the package gets shipped on a Friday
    Example: 5

  - `invalid_rates.guaranteed_service` (boolean, required)
    Indicates if the rate is guaranteed.

  - `invalid_rates.estimated_delivery_date` (string,null)
    An [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) string that represents a date, but not a specific time.  The value _may_ contain a time component, but it will be set to 00:00:00 UTC by ShipEngine.
    Example: "2018-09-23T00:00:00.000Z"

  - `invalid_rates.carrier_delivery_days` (string,null)
    The carrier delivery days

  - `invalid_rates.ship_date` (string)
    ship date

  - `invalid_rates.negotiated_rate` (boolean, required)
    Indicates if the rates been negotiated

  - `invalid_rates.service_type` (string, required)
    service type

  - `invalid_rates.service_code` (string, required)
    service code for the rate

  - `invalid_rates.trackable` (boolean, required)
    Indicates if rate is trackable

  - `invalid_rates.carrier_code` (string, required)
    carrier code

  - `invalid_rates.carrier_nickname` (string, required)
    carrier nickname

  - `invalid_rates.carrier_friendly_name` (string, required)
    carrier friendly name

  - `invalid_rates.validation_status` (string, required)
    The possible validation status values
    Enum: "valid", "invalid", "has_warnings", "unknown"

  - `invalid_rates.warning_messages` (array, required)
    The warning messages

  - `invalid_rates.error_messages` (array, required)
    The error messages

  - `rate_request_id` (string)
    A string that uniquely identifies the rate request
    Example: "se-28529731"

  - `shipment_id` (string)
    A string that uniquely identifies the shipment
    Example: "se-28529731"

  - `created_at` (string)
    When the rate was created
    Example: "2018-09-23T15:00:00.000Z"

  - `status` (string)
    The possible rate response status values
    Enum: "working", "completed", "partial", "error"

  - `errors` (array)

  - `errors.error_source` (string, required)
    The source of the error, as indicated by the name this informs us if the API call failed because of the
carrier, the order source, or the ShipEngine API itself.
    Enum: "carrier", "order_source", "shipengine"

  - `errors.error_type` (string, required)
    The type of error
    Enum: "account_status", "business_rules", "validation", "security", "system", "integrations"

  - `errors.error_code` (string, required)
    The error code specified for the failed API Call
    Enum: "auto_fund_not_supported", "batch_cannot_be_modified", "carrier_conflict", "carrier_disconnected", "carrier_not_connected", "carrier_not_supported", "confirmation_not_supported", "default_warehouse_cannot_be_deleted", "field_conflict", "field_value_required", "forbidden", "identifier_conflict", "identifiers_must_match", "insufficient_funds", "invalid_address", "invalid_billing_plan", "invalid_field_value", "invalid_identifier", "invalid_status", "invalid_string_length", "label_images_not_supported", "meter_failure", "order_source_not_active", "rate_limit_exceeded", "refresh_not_supported", "request_body_required", "return_label_not_supported", "settings_not_supported", "subscription_inactive", "terms_not_accepted", "tracking_not_supported", "trial_expired", "unauthorized", "unknown", "unspecified", "verification_failure", "warehouse_conflict", "webhook_event_type_conflict", "customs_items_required", "incompatible_paired_labels", "invalid_charge_event", "invalid_object", "no_rates_returned", "file_not_found", "shipping_rule_not_found", "service_not_determined", "no_rates_returned", "funding_source_registration_in_progress", "insurance_failure", "funding_source_missing_configuration", "funding_source_error", "freight_connection_inactive", "freight_provider_id_required", "freight_provider_already_connected", "freight_shipment_not_found", "freight_tracking_not_available", "freight_tracking_not_found", "freight_shipment_not_batchable"

  - `errors.message` (string, required)
    An error message associated with the failed API call
    Example: "Body of request cannot be null."

  - `errors.carrier_id` (string)
    A string that uniquely identifies the carrier that generated the error.
    Example: "se-28529731"

  - `errors.carrier_code` (string)
    The name of the shipping carrier that generated the error, such as fedex, dhl_express, stamps_com, etc.
    Example: "dhl_express"

  - `errors.field_name` (string)
    The name of the field that caused the error
    Example: "shipment.ship_to.phone_number"

## Response 400 fields (application/json):

  - `request_id` (string, required)
    A UUID that uniquely identifies the request id.
This can be given to the support team to help debug non-trivial issues that may occur
    Example: "aa3d8e8e-462b-4476-9618-72db7f7b7009"

  - `errors` (array, required)
    The errors associated with the failed API call

  - `errors.error_source` (string, required)
    The source of the error, as indicated by the name this informs us if the API call failed because of the
carrier, the order source, or the ShipEngine API itself.
    Enum: "carrier", "order_source", "shipengine"

  - `errors.error_type` (string, required)
    The type of error
    Enum: "account_status", "business_rules", "validation", "security", "system", "integrations"

  - `errors.error_code` (string, required)
    The error code specified for the failed API Call
    Enum: "auto_fund_not_supported", "batch_cannot_be_modified", "carrier_conflict", "carrier_disconnected", "carrier_not_connected", "carrier_not_supported", "confirmation_not_supported", "default_warehouse_cannot_be_deleted", "field_conflict", "field_value_required", "forbidden", "identifier_conflict", "identifiers_must_match", "insufficient_funds", "invalid_address", "invalid_billing_plan", "invalid_field_value", "invalid_identifier", "invalid_status", "invalid_string_length", "label_images_not_supported", "meter_failure", "order_source_not_active", "rate_limit_exceeded", "refresh_not_supported", "request_body_required", "return_label_not_supported", "settings_not_supported", "subscription_inactive", "terms_not_accepted", "tracking_not_supported", "trial_expired", "unauthorized", "unknown", "unspecified", "verification_failure", "warehouse_conflict", "webhook_event_type_conflict", "customs_items_required", "incompatible_paired_labels", "invalid_charge_event", "invalid_object", "no_rates_returned", "file_not_found", "shipping_rule_not_found", "service_not_determined", "no_rates_returned", "funding_source_registration_in_progress", "insurance_failure", "funding_source_missing_configuration", "funding_source_error", "freight_connection_inactive", "freight_provider_id_required", "freight_provider_already_connected", "freight_shipment_not_found", "freight_tracking_not_available", "freight_tracking_not_found", "freight_shipment_not_batchable"

  - `errors.message` (string, required)
    An error message associated with the failed API call
    Example: "Body of request cannot be null."

  - `errors.carrier_id` (string)
    A string that uniquely identifies the carrier that generated the error.
    Example: "se-28529731"

  - `errors.carrier_code` (string)
    The name of the shipping carrier that generated the error, such as fedex, dhl_express, stamps_com, etc.
    Example: "dhl_express"

  - `errors.field_name` (string)
    The name of the field that caused the error
    Example: "shipment.ship_to.phone_number"


